using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Drawing;

namespace ControlClick
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            gridControl1.ColCount = 2;

            gridControl1.RowCount = 6;
            gridControl1.ColWidths[2] = 500;

            gridControl1.HideRows[2] = true;
            gridControl1.HideRows[4] = true;
            gridControl1.HideRows[6] = true;

            gridControl1.RowHeights[2] = 100;
            gridControl1.RowHeights[4] = 100;
            gridControl1.RowHeights[6] = 100;


            gridControl1.ColStyles[1].CellType = "PushButton";
            gridControl1.ColStyles[1].Description = "+";

            gridControl1[2, 2].CellType = "Control";
            gridControl1[4, 2].CellType = "Control";
            gridControl1[2, 2].Control = new UserControl1();
            gridControl1[4, 2].Control = new UserControl1();

            gridControl1[6, 2].CellType = "Control";
            gridControl1[6, 2].Control = new UserControl1();


            gridControl1.CellButtonClicked += new GridCellButtonClickedEventHandler(gridControl1_CellButtonClicked);

            gridControl1.Properties.RowHeaders = false; 
        }

        void gridControl1_CellButtonClicked(object sender, GridCellButtonClickedEventArgs e)
        {
            bool b = e.Button.Text.Equals("+");
            gridControl1.HideRows[e.RowIndex + 1] = !b;
            if (b)
            {
                gridControl1.Model.CoveredRanges.Add(GridRangeInfo.Cells(e.RowIndex,e.ColIndex,e.RowIndex+1,e.ColIndex));
                gridControl1.Model[e.RowIndex,e.ColIndex].Description    = "-";
            }
            else
            {
                gridControl1.Model.CoveredRanges.Remove(GridRangeInfo.Cells(e.RowIndex,e.ColIndex,e.RowIndex+1,e.ColIndex));
                gridControl1.Model[e.RowIndex, e.ColIndex].Description = "+"; 
            }
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.Location = new System.Drawing.Point(25, 23);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.SerializeCellsBehavior = Syncfusion.Windows.Forms.Grid.GridSerializeCellsBehavior.SerializeAsRangeStylesIntoCode;
            this.gridControl1.Size = new System.Drawing.Size(621, 287);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.TabIndex = 0;
            this.gridControl1.Text = "gridControl1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(672, 350);
            this.Controls.Add(this.gridControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private void gridControl1_CellClick(object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e)
		{
			if(e.RowIndex == 1 || e.RowIndex == 3)
			{ 
				if (this.gridControl1.CurrentCell.HasCurrentCellAt(e.RowIndex, e.ColIndex))
				{ 
					GridCellLayout layout = this.gridControl1.GetCellRenderer(e.RowIndex, e.ColIndex).GetCellLayout(e.RowIndex, e.ColIndex, this.gridControl1.Model[e.RowIndex, e.ColIndex]);
					bool clickOnCell = layout.ClientRectangle.Contains(new Point(e.MouseEventArgs.X, e.MouseEventArgs.Y));

					Control focusControl = this.gridControl1[e.RowIndex, e.ColIndex].Control;
					bool beginEdit = focusControl != null; 

					if (beginEdit)
					{
						this.gridControl1.CurrentCell.BeginEdit();
						if (this.gridControl1.CurrentCell.HasControlFocus && e.MouseEventArgs.Button == MouseButtons.Left)
						{
							this.gridControl1.Update();
							Point loc = layout.ClientRectangle.Location;

							Point targetPoint = new Point(e.MouseEventArgs.X-loc.X, e.MouseEventArgs.Y-loc.Y);

							Control targetControl = focusControl.GetChildAtPoint(targetPoint);

							if (targetControl == null)
								targetControl = focusControl;
							else
							{
								Point childLocation = targetControl.Location;
								targetPoint = new Point(targetPoint.X-childLocation.X, targetPoint.Y-childLocation.Y);
							}

							ActiveXSnapshot.FakeLeftMouseClick(targetControl, targetPoint);
						}
					}
				}

			}
		}

	}
}